import { SchemaInitializerItemOptions } from '@nocobase/client';
import { useWorkflowVariableOptions } from '../variable';
import { RadioWithTooltip } from '../components/RadioWithTooltip';
declare const _default: {
    title: string;
    type: string;
    group: string;
    fieldset: {
        'config.engine': {
            type: string;
            title: string;
            name: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                options: any[];
            };
            required: boolean;
            default: string;
        };
        'config.expression': {
            type: string;
            title: string;
            name: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                scope: string;
            };
            "x-validator"(value: any, rules: any, { form }: {
                form: any;
            }): string;
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    schema: {
                        description: string;
                    };
                };
            };
            required: boolean;
        };
    };
    view: {};
    scope: {
        useWorkflowVariableOptions: typeof useWorkflowVariableOptions;
        renderReference: (key: string) => JSX.Element;
    };
    components: {
        CalculationResult({ dataSource }: {
            dataSource: any;
        }): string | JSX.Element;
        RadioWithTooltip: typeof RadioWithTooltip;
    };
    getOptions(config: any, types: any): any[];
    useInitializers(node: any): SchemaInitializerItemOptions;
};
export default _default;
