import { SchemaInitializerItemOptions } from '@nocobase/client';
import { CollectionFieldInitializers } from '../../components/CollectionFieldInitializers';
import { SchemaConfig, SchemaConfigButton } from './SchemaConfig';
import { ModeConfig } from './ModeConfig';
import { AssigneesSelect } from './AssigneesSelect';
declare const _default: {
    title: string;
    type: string;
    group: string;
    fieldset: {
        'config.assignees': {
            type: string;
            name: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {};
            required: boolean;
            default: any[];
        };
        'config.mode': {
            type: string;
            name: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            default: number;
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            };
        };
        'config.schema': {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            properties: {
                schema: {
                    type: string;
                    'x-component': string;
                };
            };
        };
    };
    view: {};
    scope: {};
    components: {
        SchemaConfigButton: typeof SchemaConfigButton;
        SchemaConfig: typeof SchemaConfig;
        ModeConfig: typeof ModeConfig;
        AssigneesSelect: typeof AssigneesSelect;
    };
    getOptions(config: any, types: any): any;
    useInitializers(node: any): SchemaInitializerItemOptions | null;
    initializers: {
        CollectionFieldInitializers: typeof CollectionFieldInitializers;
    };
};
export default _default;
