import { SchemaInitializerItemOptions, useCollectionDataSource } from '@nocobase/client';
import { CollectionFieldInitializers } from '../components/CollectionFieldInitializers';
import { FilterDynamicComponent } from '../components/FilterDynamicComponent';
declare const _default: {
    title: string;
    type: string;
    group: string;
    fieldset: {
        'config.collection': {
            type: string;
            title: string;
            name: string;
            required: boolean;
            'x-reactions': string[];
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                placeholder: string;
            };
        };
        'config.params': {
            type: string;
            name: string;
            title: string;
            'x-decorator': string;
            properties: {
                filter: {
                    type: string;
                    title: string;
                    name: string;
                    'x-decorator': string;
                    'x-decorator-props': {
                        labelAlign: string;
                        className: string;
                    };
                    'x-component': string;
                    'x-component-props': {
                        useProps(): {
                            options: any[];
                            className: string;
                        };
                        dynamicComponent: string;
                    };
                };
            };
        };
    };
    view: {};
    scope: {
        useCollectionDataSource: typeof useCollectionDataSource;
    };
    components: {
        FilterDynamicComponent: typeof FilterDynamicComponent;
    };
    getOptions(config: any, types: any): any;
    useInitializers(node: any): SchemaInitializerItemOptions | null;
    initializers: {
        CollectionFieldInitializers: typeof CollectionFieldInitializers;
    };
};
export default _default;
