"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _collection = require("../schemas/collection");

var _locale = require("../locale");

var _CollectionBlockInitializer = require("../components/CollectionBlockInitializer");

var _CollectionFieldInitializers = require("../components/CollectionFieldInitializers");

var _FilterDynamicComponent = require("../components/FilterDynamicComponent");

var _variable = require("../variable");

var _default = {
  title: `{{t("Query record", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'query',
  group: 'collection',
  fieldset: {
    'config.collection': _collection.collection,
    // 'config.multiple': {
    //   type: 'boolean',
    //   title: `{{t("Multiple records", { ns: "${NAMESPACE}" })}}`,
    //   name: 'config.multiple',
    //   'x-decorator': 'FormItem',
    //   'x-component': 'Checkbox',
    //   'x-component-props': {
    //     disabled: true
    //   }
    // },
    'config.params': {
      type: 'object',
      name: 'config.params',
      title: '',
      'x-decorator': 'FormItem',
      properties: {
        filter: _collection.filter
      }
    }
  },
  view: {},
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    FilterDynamicComponent: _FilterDynamicComponent.FilterDynamicComponent
  },

  getOptions(config, types) {
    return (0, _variable.useCollectionFieldOptions)({
      collection: config.collection,
      types
    });
  },

  useInitializers(node) {
    var _node$title;

    if (!node.config.collection) {
      return null;
    }

    return {
      type: 'item',
      title: (_node$title = node.title) !== null && _node$title !== void 0 ? _node$title : `#${node.id}`,
      component: _CollectionBlockInitializer.CollectionBlockInitializer,
      collection: node.config.collection,
      dataSource: `{{$jobsMapByNodeId.${node.id}}}`
    };
  },

  initializers: {
    CollectionFieldInitializers: _CollectionFieldInitializers.CollectionFieldInitializers
  }
};
exports.default = _default;